
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>使用Maven对JAVA程序打包－带主类、带依赖【转】 / 憋错料</title>

    <meta name="description" content="使用Maven对JAVA程序打包－带主类、带依赖【转】 很多时候,我们需要对编写的程序进行打包,这个时候,我们可以借助一些项目构建工具,如maven, sbt, ant等,这里我使用的是maven. 打包成可执行有主类的jar包(jar包中无依赖) 以下是配置打包成可执行,带主类的jar包: &lt;project&gt; ... &lt;build&gt; &lt;plugins&gt; &lt;plugin&gt; &lt;groupId&gt;org.apache.maven.plugins&lt;/groupId&gt; &lt;artifa ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">使用Maven对JAVA程序打包－带主类、带依赖【转】</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>很多时候，我们需要对编写的程序进行打包，这个时候，我们可以借助一些项目构建工具，如maven, sbt, ant等，这里我使用的是maven。</p>
<h1>打包成可执行有主类的jar包(jar包中无依赖)</h1>
<p>以下是配置打包成可执行，带主类的jar包：</p>
<pre><code>&lt;project&gt;
  ...
  &lt;build&gt;
    &lt;plugins&gt;
      &lt;plugin&gt;
        &lt;groupId&gt;org.apache.maven.plugins&lt;/groupId&gt;
        &lt;artifactId&gt;maven-jar-plugin&lt;/artifactId&gt;
        ...
        &lt;configuration&gt;
          &lt;archive&gt;
            &lt;manifest&gt;
              &lt;addClasspath&gt;true&lt;/addClasspath&gt;
              &lt;mainClass&gt;fully.qualified.MainClass&lt;/mainClass&gt; &lt;!-- 你的主类名 --&gt;
            &lt;/manifest&gt;
          &lt;/archive&gt;
        &lt;/configuration&gt;
        ...
      &lt;/plugin&gt;
    &lt;/plugins&gt;
  &lt;/build&gt;</code></pre>
<p>But, 虽然现在把程序打包成了jar文件，也可以运行，但是，这个jar包是没有包含依赖的，因此，如果这个程序有其他依赖，那么在运行这个程序的时候，需要指定类目录，并且要把所有的依赖都放到类目录下去，手动添加依赖到类目录下，简直就是恶梦。。。</p>
<p>我曾经就这么干过，它少一个依赖，我就手动加一个到类目录，少一个，加一个，少一个，加一个，当我加了大概有10几个之后，而且还看不到尽头。。。简直要疯的节奏，然后想起之前用sbt打包，也是可以把依赖添加到jar包，心情顿时好转，赶紧google，于是找到google到了maven的官网…。顺便说一下，虽然我们google的时候，会搜索到很多结果，但很多时候，我们最好选择合适的结果进行阅读，我的一般顺序是：官方优先，StackExchange。。。</p>
<h1>打包成带依赖的jar包</h1>
<h2>配置</h2>
<h3>不加main类而带依赖的jar包</h3>
<p>编辑pom.xml文件，内容如下：</p>
<pre><code>&lt;project&gt;
  [...]
  &lt;build&gt;
    [...]
    &lt;plugins&gt;
      &lt;plugin&gt;
        &lt;artifactId&gt;maven-assembly-plugin&lt;/artifactId&gt;
        &lt;version&gt;3.0.0&lt;/version&gt;
        &lt;configuration&gt;
          &lt;descriptorRefs&gt;
            &lt;descriptorRef&gt;jar-with-dependencies&lt;/descriptorRef&gt;
          &lt;/descriptorRefs&gt;
        &lt;/configuration&gt;
        &lt;executions&gt;
          &lt;execution&gt;
            &lt;id&gt;make-assembly&lt;/id&gt; &lt;!-- this is used for inheritance merges --&gt;
            &lt;phase&gt;package&lt;/phase&gt; &lt;!-- bind to the packaging phase --&gt;
            &lt;goals&gt;
              &lt;goal&gt;single&lt;/goal&gt;
            &lt;/goals&gt;
          &lt;/execution&gt;
        &lt;/executions&gt;
      &lt;/plugin&gt;
      [...]
&lt;/project&gt;</code></pre>
<h3>加main类也带依赖的jar包</h3>
<p>编辑pom.xml文件，内容如下：</p>
<pre><code>&lt;project&gt;
    &lt;build&gt;
        &lt;plugins&gt;
            &lt;!--(start) for package jar with dependencies --&gt;
            &lt;plugin&gt;
                &lt;artifactId&gt;maven-assembly-plugin&lt;/artifactId&gt;
                &lt;version&gt;3.0.0&lt;/version&gt;
                &lt;configuration&gt;
                    &lt;archive&gt;
                        &lt;manifest&gt;
                            &lt;mainClass&gt;Main&lt;/mainClass&gt;
                        &lt;/manifest&gt;
                    &lt;/archive&gt;
                    &lt;descriptorRefs&gt;
                        &lt;descriptorRef&gt;jar-with-dependencies&lt;/descriptorRef&gt;
                    &lt;/descriptorRefs&gt;
                &lt;/configuration&gt;
                &lt;executions&gt;
                    &lt;execution&gt;
                        &lt;id&gt;make-assembly&lt;/id&gt; &lt;!-- this is used for inheritance merges --&gt;
                        &lt;phase&gt;package&lt;/phase&gt; &lt;!-- bind to the packaging phase --&gt;
                        &lt;goals&gt;
                            &lt;goal&gt;single&lt;/goal&gt;
                        &lt;/goals&gt;
                    &lt;/execution&gt;
                &lt;/executions&gt;
            &lt;/plugin&gt;
            &lt;!--(end) for package jar with dependencies --&gt;
        &lt;/plugins&gt;
    &lt;/build&gt;
&lt;/project&gt;</code></pre>
<p>值得注意的是，不要像以下那样修改pom.xml文件，那样虽然不会报错，但生成的jar包中的<code>MANIFEST.MF</code>中没有主类，这样的jar包无法直接运行。</p>
<pre><code>&lt;project&gt;
  [...]
  &lt;build&gt;
    [...]
    &lt;plugins&gt;
      &lt;plugin&gt;
        &lt;groupId&gt;org.apache.maven.plugins&lt;/groupId&gt;
        &lt;artifactId&gt;maven-jar-plugin&lt;/artifactId&gt;
        ...
        &lt;configuration&gt;
          &lt;archive&gt;
            &lt;manifest&gt;
              &lt;addClasspath&gt;true&lt;/addClasspath&gt;
              &lt;mainClass&gt;fully.qualified.MainClass&lt;/mainClass&gt; &lt;!-- 你的主类名 --&gt;
            &lt;/manifest&gt;
          &lt;/archive&gt;
        &lt;/configuration&gt;
        ...
      &lt;/plugin&gt;
      &lt;plugin&gt;
        &lt;artifactId&gt;maven-assembly-plugin&lt;/artifactId&gt;
        &lt;version&gt;3.0.0&lt;/version&gt;
        &lt;configuration&gt;
          &lt;descriptorRefs&gt;
            &lt;descriptorRef&gt;jar-with-dependencies&lt;/descriptorRef&gt;
          &lt;/descriptorRefs&gt;
        &lt;/configuration&gt;
        &lt;executions&gt;
          &lt;execution&gt;
            &lt;id&gt;make-assembly&lt;/id&gt; &lt;!-- this is used for inheritance merges --&gt;
            &lt;phase&gt;package&lt;/phase&gt; &lt;!-- bind to the packaging phase --&gt;
            &lt;goals&gt;
              &lt;goal&gt;single&lt;/goal&gt;
            &lt;/goals&gt;
          &lt;/execution&gt;
        &lt;/executions&gt;
      &lt;/plugin&gt;
      [...]
&lt;/project&gt;</code></pre>
<h2>打包</h2>
<p>使用以下命令打包：</p>
<pre><code>mvn package</code></pre>
<p>就像官方网站说的，” this is pretty simple! “</p>
<hr>
<br />然而，当在运行操作hdfs的jar包时，我出现了以下问题：</p>
<pre><code>Exception in thread "main" java.io.IOException: No FileSystem for scheme: hdfs
        at org.apache.hadoop.fs.FileSystem.getFileSystemClass(FileSystem.java:2660)
        at org.apache.hadoop.fs.FileSystem.createFileSystem(FileSystem.java:2667)
        at org.apache.hadoop.fs.FileSystem.access$200(FileSystem.java:94)
        at org.apache.hadoop.fs.FileSystem$Cache.getInternal(FileSystem.java:2703)
        at org.apache.hadoop.fs.FileSystem$Cache.get(FileSystem.java:2685)
        at org.apache.hadoop.fs.FileSystem.get(FileSystem.java:373)
        at sentry.magic.fs.Dfs.&lt;init&gt;(Dfs.java:20)
        at sentry.magic.fs.CheckFlumeIsCompleted.&lt;init&gt;(CheckFlumeIsCompleted.java:26)
        at Main.main(Main.java:26)</code></pre>
<p>好在有位仁兄[2]也遇到了这个问题，从而使得问题解决。解决方法如下：</p>
<pre><code>    FileSystem dfs = null;
    Configuration conf = new Configuration();

    public Dfs(URI uri) throws IOException {

        // 必须有下面这一句
        conf.set("fs.hdfs.impl","org.apache.hadoop.hdfs.DistributedFileSystem");
        // 必须有上面那一句

        dfs = FileSystem.get(uri,conf);
    }</code></pre>
<p>除了他之种方法之外，我也自己摸索出了一种方法，经过实践，也是可行的，我的方法如下：&nbsp;<br />找到打包好的jar包，然后使用归档管理器打开这个jar包，即“open with archive manager”,找到<code>META-INFO/services</code>目录，再找到这个目录下的<code>org.apache.<a href="http://lib.csdn.net/base/hadoop" rel="external nofollow noreferrer">Hadoop</a>.fs.FileSystem</code>文件，编辑这个文件，在文件末尾加上一行：</p>
<pre><code>org.apache.hadoop.hdfs.DistributedFileSystem</code></pre>
<p>但是，这么修改jar的方法，不太合适，因为每生成一次，需要修改一次，所以，建议暂时使用前面那种解决方法。</p>
<p>参考文献：</p>
<p>[1]&nbsp;<a href="https://maven.apache.org/plugins/maven-assembly-plugin/usage.html" rel="external nofollow noreferrer">https://maven.apache.org/plugins/maven-assembly-plugin/usage.html</a>&nbsp;<br />[2]&nbsp;<a href="http://www.cnblogs.com/justinzhang/p/4983673.html" rel="external nofollow noreferrer">http://www.cnblogs.com/justinzhang/p/4983673.html</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-02 15:38:35 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/html/" title="html">html</a>, <a href="https://www.biecuoliao.com/tag/googl/" title="googl">googl</a>, <a href="https://www.biecuoliao.com/tag/ted/" title="ted">ted</a>, <a href="https://www.biecuoliao.com/tag/make/" title="make">make</a>, <a href="https://www.biecuoliao.com/tag/version/" title="version">version</a>, <a href="https://www.biecuoliao.com/tag/xml%e6%96%87%e4%bb%b6/" title="xml文件">xml文件</a>, <a href="https://www.biecuoliao.com/tag/arc/" title="arc">arc</a>, <a href="https://www.biecuoliao.com/tag/%e7%9f%a5%e8%af%86%e5%ba%93/" title="知识库">知识库</a>, <a href="https://www.biecuoliao.com/tag/classpath/" title="classpath">classpath</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>使用Maven对JAVA程序打包－带主类、带依赖【转】的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0aDkVgM.html" rel="bookmark">java程序打包成jar包</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				方法一:通过jar命令 jar命令的用法: 下面是jar命令的帮助说明: 用法:jar {ctxui}[vfm0Me] [jar-file] [manifest-file] [entry-point] [-C dir] files ... 选项包括:    -c  创建新的归档文件    -t  列出归档目录    -x  解压缩已归档的指定(或所有)文件    -u  更新现有的归档文件    -v  在标准输出中生成详细输出    -f  指定归档文件名    -m  包含指定清单文件中的清			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPZOmm3.html" rel="bookmark">java程序打包jre以及制作安装包</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				分享一篇文章: java程序打包jre以及制作安装包 传智&amp;黑马咨询郑老师 java程序打包jre以及制作安装包Java的桌面程序写好以后只能在eclipse下运行是不可以的,还需要将程序拷贝到其他电脑上运行才可以,所以需要制作成其他电脑可以运行的文件,当然在安装有jdk的电脑上只需要将程序导出为jar文件就可以运行了,但是除了开发java程序人员的电脑上会安装jdk,其他人的电脑上不会有这个环境,所以还需要将java可运行的环境一同打包到程序中去,这样,在用户不安装jdk的情况下也可以运行.制			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41BWooM.html" rel="bookmark">【Java】Java程序打包成jar包在Linux上运行</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				当需要把在Windows上开发的Java程序用在Linux上运行时,就需要吧该Java程序打包成jar包上传到Linux上去运行. 1.Java程序用MyEclipse打包成可运行的jar包 (1)在MyEclipse中选中需要打包的项目,点击右键,选择:Export... 如下图所示: (2)然后在弹出的窗口中选择:Java--&gt;Runnable JAR file,然后点击:Next,如下图所示: (3)然后选择需要打包的程序和保存的地方,然后点击:Finish,如下图所示: 这样Java程序			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Qwz6L0.html" rel="bookmark">install4j 工具为java程序打包exe</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				用 install4j 工具为java程序打包exe 制作人:mark 制作时间:2013-05-02 ? 用Eclipse 将程序源码打包成jar文件. 打包jar方法我不做介绍了,相信大家都会,不会的百度一下吧. 准备工作. 将导出的jar包:aaa.jar,程序需要的图片:images,数据库database,以及你要生成exe文件后的图标 png图片,全部复制到一个SMMS文件夹下面. 打开安装好的install4j文件 输入程序全名Full Name,程序简称 Short Name,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPeDwD0.html" rel="bookmark">Java程序打包</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				包名为 com.longneo.data,主程序入口为:com.longneo.data.AppMain 1.到工程目录下 /bin 执行 jar -cvf Demo.jar com 执行完之后会生成 Demo.jar 文件 文件目录如下: --com ------longneo --------------data ------------------AppMain.class --METE-INF ------------MANI-FEST.MF --com --META-INF 2.手动修			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDXY57M.html" rel="bookmark">把Java程序打包成jar文件包并执行</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				把Java程序打包成jar文件包并执行 1.首先要确认自己写的程序有没有报错. 2.第一次我写的是Web Project到现在,我一直没有执行成功,所以最好创建的是java Project 打包步骤: 1.在项目上,右键,选择Export. 2.进入到下图界面,选择Java 下面的JAR file 3.选择项目,确认必要的文件是否选中,选择保存jar文件包的路径,如下图 4.完成步骤3之后,点击Next,进入如下图界面: 5.直接点Next,进入下面的界面: 6.直接点Finish,jar文件包			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoqGEn3.html" rel="bookmark">将Java程序打包成可执行EXE文件的步骤</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				需要的工具myeclipse .jar2exe(附上下载地址,直接解压就可以用链接: https://pan.baidu.com/s/1qYPRgXu 密码: wbva) 1.将Java项目导出成.jar包 鼠标右键项目名,选择导出 导出的方式选择Runnable JAR file,点击next继续 选择导出文件的路径: jar文件成功导出到桌面 2.用工具将jar文件打包成EXE可执行文件 选择刚才导出的jar文件 选择要导出程序的类型: 选择主类,图片可不选 导出程序的具体设置: 选择辅助j			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0d7P9wM.html" rel="bookmark">Java 找不到主类错误</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Eclipse 运行java 程序,突然出现错误:没有或找不到主类. 在网上找了好多办法,都不行. jdk环境配置啊--&gt;这个一般不会出错,因为以前都不会出现这种问题. 查看项目配置啥的--&gt;这也没用,因为以前都没事. 在cmd 运行java程序,可以通过编译,还有,程序中如果有package语句,无法执行.去掉package,程序也出来了. 可是在eclipse下就是不行. 整了半天,在项目右键下,突然发现了 Build Project, 艹,build一下,好了.这eclipse 是抽了什			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyoOWm3.html" rel="bookmark">Java找不到主类引发的探究</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一. 同一目录下,两个文件 t.java console.bat t.java: package t; public class t{ public static void main(String[] args){ System.out.println(&quot;Hello world!&quot;); } } console.bat: @ECHO OFF SET JAVAHOME=D:\Java\JDK-8u91-1.8.0_91 SET PATH=%PATH%;%JAVAHOME%\bin;%JAV			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q0xr1D4.html" rel="bookmark" class="title">Performance Monitor Usage5：View Report</a>
					<div>
						1,当Data Collector Set 停止运行后,在Reports Catalog-&gt;User Defined-&gt;DataCollectorSet_PhysicalDisk 下,会有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/x0dY7z3.html" rel="bookmark" class="title">浏览器渲染过程</a>
					<div>
						有时候想要进行性能优化时了解浏览器的渲染过程无疑是十分重要的.下面来看 首先介绍一下主流浏览器的渲染引擎: IE:Trident chrome:Blink Safire:webkit Firefox: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/k0eK1J4.html" rel="bookmark" class="title">&lowbar;cpluscplus</a>
					<div>
						_cpluscplus是c++中的定义,而c中没有该定义 1.用来判定代码是c类型还是c++类型 2._cplusplus的类型是&quot;long int&quot;,值为199711L 1 in ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jyQJAM.html" rel="bookmark" class="title">&lbrack;GitHub&rsqb; 保持 Fork 后的仓库与原仓库同步</a>
					<div>
						Clone 自己 Fork 后的仓库 $ git clone [email protected]:&lt;username&gt;/&lt;reponame&gt;.git $ cd &lt;repo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dAnQZ3.html" rel="bookmark" class="title">编译时、运行时、构建时（二）</a>
					<div>
						泛型(又称类型检验):这个是发生在编译期的.编译器负责检查程序中类型的正确性,然后把使用了泛型的代码翻译或者重写成可以执行在当前JVM上的非泛型代码.这个技术被称为“类型擦除“.换句话来说,编译器会擦 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXQRlX0.html" rel="bookmark" class="title">iOS学习笔记-精华整理</a>
					<div>
						iOS学习笔记总结整理 一.内存管理情况 1- autorelease,当用户的代码在持续运行时,自动释放池是不会被销毁的,这段时间内用户可以安全地使用自动释放的对象.当用户的代码运行告一段 落,开始 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pzD8R0.html" rel="bookmark" class="title">9、Cocos2dx 3&period;0游戏开发找小三之工厂方法模式与对象传值</a>
					<div>
						重开发者的劳动成果,转载的时候请务必注明出处:http://blog.csdn.net/haomengzhu/article/details/27704153 工厂方法模式 工厂方法是程序设计中一个经 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j1LEVM.html" rel="bookmark" class="title">hadoop安装包的目录结构</a>
					<div>
						初次接触Hadoop,了解了Hadoop安装包的目录结构,和大家分享下: bin:Hadoop最基本的管理脚本和使用脚本的目录,这些脚本是sbin目录下管理脚本的基础实现,用户可以直接使用这些脚本管理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aYoVv0.html" rel="bookmark" class="title">iOS-TCP&sol;IP、Http、Socket的区别</a>
					<div>
						网络由下往上分为 物理层.数据链路层.网络层.传输层.会话层.表示层和应用层. 通过初步的了解,我知道IP协议对应于网络层,TCP协议对应于传输层,而HTTP协议对应于应用层, 三者从本质上来说没有可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35AKXE3.html" rel="bookmark" class="title">基础学习总结（二）</a>
					<div>
						用户界面View 五大布局: 1.LinearLayout 线性布局 2.RelativeLayout 相对布局 5.AbsoluteLayout 绝对布局 4.TableLayout 表格布局 3. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lew7b3.html" rel="bookmark" class="title">mysql单表查询语句优化</a>
					<div>
						Mysql语句优化 范例1:优化语句SELECT * FROM `tbl_order_buy_eta` WHERE `id_order`=1843 #通过explain分析语句结果如下 mysql&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02Z8nn0.html" rel="bookmark" class="title">Web负载均衡（ipvsadm&comma;DR模式）</a>
					<div>
						Ubuntu 上ipvsadm负载均衡(DR模式,以80端口为例) 说明:3台服务器,ip分别为:10.0.1.2  10.0.1.3  10.0.1.4  虚拟ip:10.0.1.10 ipvsad ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0doDJ7M.html" rel="bookmark" class="title">春风十里</a>
					<div>
											</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38pYy13.html" rel="bookmark" class="title">VS2015 VNext学习笔记02：Bower和Grunt</a>
					<div>
						1.概述 (首先声明本人英语水平有限,专业术语也不好恰当翻译,所以有些单词还是不要翻译为好吧) Bower:一个&quot;web包管理&quot;,允许您安装和还原客户端软件包,包含 JavaScr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lNngL4.html" rel="bookmark" class="title">浅谈VBA</a>
					<div>
						VBA,全称Visual Basic for Applications,其中的一些专业性的解释可以自行搜索,这里就不一一介绍.半年以前,我是不知道VBA的,当我听到VBA的时候,我却迷糊了.VBA是什 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0neXmoM.html" rel="bookmark" class="title">&period;NET 进程和线程</a>
					<div>
						一.进程:需要有用Process类用法一:Process.Start(&quot;calc&quot;);该方法弊端:有许多程序不知道它的运行名字到底是什么,如果写错了,就会出现程序崩溃错误用法二:/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rPYYXM.html" rel="bookmark" class="title">可编辑 可选择的textrear</a>
					<div>
						1 @using GMS.Framework.Contract 2 @using GMS.Framework.Web.Controls 3 @using GMS.Mrs.Disaster.Contra ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38yVvW4.html" rel="bookmark" class="title">最近在读的书</a>
					<div>
						读书记录 非技术类: 1.&lt;不丹,我前世的王国&gt; 杨二车娜姆著-------Bhutan,Kingdom of my past life 对不丹有了初步的印象,世界上第一个全面禁烟的国家, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGeE6G3.html" rel="bookmark" class="title">grunt-contrib-cssmin CSS压缩以及合并</a>
					<div>
						grunt-contrib-cssmin:压缩以及合并CSS文件 安装插件:npm install grunt-contrib-cssmin --save-dev 不设置compatibility与n ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lDOEP0.html" rel="bookmark" class="title">C&num; WindowsService安装与卸载</a>
					<div>
						最近在做WinService,总结了一下安装和卸载程序,服务实现内容无法总结了. 安装程序: 1 using System; 2 using System.Collections.Generic; 3 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.022 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
